# Swerve Module Physical Properties

## Swerve Module Physical Properties (`physicalproperties.json`)

This JSON configures the physical properties shared with all the Swerve Modules. It maps 1:1 with [`PhysicalPropertiesJson.java`](https://github.com/BroncBotz3481/YAGSL-Example/tree/main/src/main/java/swervelib/parser/json/PhysicalPropertiesJson.java) which creates [`SwerveModulePhysicalCharacteristics.java`](https://github.com/BroncBotz3481/YAGSL-Example/tree/main/src/main/java/swervelib/parser/SwerveModulePhysicalCharacteristics.java).

## Fields

| Name                             | Units                             | Required | Description                                                                                            |
| -------------------------------- | --------------------------------- | -------- | ------------------------------------------------------------------------------------------------------ |
| `conversionFactor`               | [MotorConfig](#motorconfig)       | N        | Conversion factor applied to the motor controller for the onboard PID.                                 |
| `optimalVoltage`                 | Voltage                           | Y        | Optimal voltage to compensate to and base feedforward calculations off of.                             |
| `currentLimit`                   | [MotorConfig](#motorconfig)       | N        | The current limit in AMPs to apply to the motors.                                                      |
| `rampRate`                       | [MotorConfig](#motorconfig)       | N        | The minimum number of seconds to take for the motor to go from 0 to full throttle.                     |
| `wheelGripCoefficientOfFriction` | Coefficient of Friction on Carpet | N        | The grip tape coefficient of friction on carpet. Used to calculate the practical maximum acceleration. |

#### MotorConfig

| Name    | Units  | Required | Description        |
| ------- | ------ | -------- | ------------------ |
| `drive` | Number | Y        | Drive motor value. |
| `angle` | Number | Y        | Angle motor value. |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yagsl.com/legacy-documentation/documentation/swerve-module-physical-properties.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
